From 047223384ee12c63da523d61a7bdbb4d740e2e1b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 18 2020 18:35:39 +0000
Subject: [PATCH 169/2232] Make trycatch sfinae work on msvc


---

diff --git a/gen/write.rs b/gen/write.rs
index de2d0cd..9a33fc5 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -210,20 +210,19 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     if needs_trycatch {
         out.begin_block("namespace behavior");
         out.include.exception = true;
-        writeln!(out, "struct trycatch {{");
-        writeln!(out, "  template <typename T> trycatch(T);");
-        writeln!(out, "  static char use_default;");
-        writeln!(out, "}};");
+        out.include.type_traits = true;
+        out.include.utility = true;
+        writeln!(out, "class missing {{}};");
+        writeln!(out, "missing trycatch(...);");
         writeln!(out);
-        writeln!(out, "template <typename Try, typename Fail,");
-        writeln!(
-            out,
-            "          typename = decltype(trycatch(std::declval<Try>()).use_default)>",
-        );
+        writeln!(out, "template <typename Try, typename Fail>");
+        writeln!(out, "static typename std::enable_if<");
         writeln!(
             out,
-            "static void trycatch(Try &&func, Fail &&fail) noexcept try {{",
+            "    std::is_same<decltype(trycatch(std::declval<Try>(), std::declval<Fail>())),",
         );
+        writeln!(out, "                 missing>::value>::type");
+        writeln!(out, "trycatch(Try &&func, Fail &&fail) noexcept try {{");
         writeln!(out, "  func();");
         writeln!(out, "}} catch (const ::std::exception &e) {{");
         writeln!(out, "  fail(e.what());");

